﻿@model LoyaltyPointEngine.Model.Object.Campaign.CampaignModel
@{

}
<!--=== Page Header ===-->
<div class="page-header">
    <div class="page-title">
        <h3>Edit Campaign</h3>
    </div>
    <!-- /Page Stats -->
</div>
<!-- /Page Header -->
<!--=== Page Content ===-->
<div class="row">
    <!--=== Validation Example 1 ===-->
    <div class="col-md-12">
        <div class="widget box">
            <div class="widget-header">
                <h4><i class="icon-reorder"></i> Edit Campaign</h4>
            </div>
            <div class="widget-content">
                @using (Html.BeginForm(MVC.Campaign.Edit(), FormMethod.Post, new { @class = "form-horizontal row-border", @id = "formEditCampaign" }))
                {
                    @Html.AntiForgeryToken()

                    if (!Html.ViewData.ModelState.IsValid)
                    {
                        <div class="alert alert-danger">
                            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                            <i class="fa fa-times-circle"></i>
                            Error occured: <br />
                            @Html.ValidationSummary()
                        </div>
                    }

                    @Html.HiddenFor(x => x.ID)

                    <div class="form-group">
                        <label class="col-md-3 control-label">Campaign Code <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.Code, new { @class = "form-control required", maxlength = "50" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Campaign Name <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.Name, new { @class = "form-control required" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">StartDate <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrStartDate, new { @class = "form-control datepicker2 required" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">StartTime <span class="required">*</span></label>
                        <div class="col-md-9">
                            <input type="text" id="StrStartTime" name="StrStartTime" class="form-control" data-mask="99:99:99" value="@Model.StrStartTime"><span class="help-block">HH:MM:SS</span>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">EndDate <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrEndDate, new { @class = "form-control datepicker2 required" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">EndTime <span class="required">*</span></label>
                        <div class="col-md-9">
                            <input type="text" id="StrEndTime" name="StrEndTime" class="form-control" data-mask="99:99:99" value="@Model.StrEndTime"><span class="help-block">HH:MM:SS</span>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Type <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.DropDownListFor(x => x.Type, ViewBag.ListCampaignType as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix required" })
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">Value <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.Value, new { @class = "form-control" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">IsActive <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.CheckBoxFor(x => x.IsActive, new { @class = "form-control uniform" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">CapGenerationPoint <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.CapGenerationPoint, new { @class = "form-control required" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Assigned to Channel <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.ListBoxFor(x => x.Channels, (MultiSelectList)ViewBag.ListChannel, new { @class = "form-control required", multiple = "multiple", @size = ViewBag.ListChannel.Items.Count })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">IsFirstSubmit </label>
                        <div class="col-md-9">
                            @Html.CheckBoxFor(x => x.IsFirstSubmit, new { @class = "form-control uniform", @id = "cekFirstSubmit" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">IsAutomate <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.CheckBoxFor(x => x.IsAutomate, new { @class = "form-control uniform", @id = "cekAutomate", @OnClick = "showMe('formRole')" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">IsExpiredPerUser </label>
                        <div class="col-md-9">
                            @Html.CheckBoxFor(x => x.IsExpiredPerUser, new { @class = "form-control uniform", @id = "cekExpiredPerUser", @OnClick = "showThis('formExpire')" })
                        </div>
                    </div>
                    <div id="formExpire" style="display:none">
                        <label class="col-md-3 control-label">ExpireIn (days) </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.ExpireIn, new { @class = "form-control uniform" })
                        </div>
                    </div>
                    <hr />
                    <h4>List Action To Campaign</h4>
                    <div class="widget-content clearfix">
                        <!-- Left box -->
                        <div class="left-box">
                            <input type="text" id="box1Filter" class="form-control box-filter" placeholder="Filter entries..."><button type="button" id="box1Clear" class="filter">x</button>
                            <span>Action List</span>
                            @Html.DropDownListFor(x => x.ActionList, ViewBag.ListAction as IEnumerable<SelectListItem>, new { @class = "multiple", @multiple = "multiple", @id = "box1View" })
                            <span id="box1Counter" class="count-label"></span>
                            <select id="box1Storage"></select>
                        </div>
                        <!--left-box -->
                        <!-- Control buttons -->
                        <div class="dual-control">
                            <button id="to2" type="button" class="btn">&nbsp;&gt;&nbsp;</button>
                            <button id="allTo2" type="button" class="btn">&nbsp;&gt;&gt;&nbsp;</button><br>
                            <button id="to1" type="button" class="btn">&nbsp;&lt;&nbsp;</button>
                            <button id="allTo1" type="button" class="btn">&nbsp;&lt;&lt;&nbsp;</button>
                        </div>
                        <!--control buttons -->
                        <!-- Right box -->
                        <div class="right-box">
                            <input type="text" id="box2Filter" class="form-control box-filter" placeholder="Filter entries..."><button type="button" id="box2Clear" class="filter">x</button>
                            <span>Campaign Action List</span>
                            @Html.DropDownListFor(x => x.CampaignActionList, ViewBag.ListCampaignAction as IEnumerable<SelectListItem>, new { @class = "multiple", @multiple = "multiple", @id = "box2View" })
                            <span id="box2Counter" class="count-label"></span>
                            <select id="box2Storage"></select>
                        </div>
                        <!--right box -->
                    </div>
                    <hr />
                    <div id="formRole" style="display:none">
                        <h4>List Action To Campaign</h4>
                        <div class="widget-content clearfix">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="col-md-3 control-label">Name Action </label>
                                    <div class="col-md-9">
                                        <select class="form-control" id="nameAction" name=" nameActionValue"></select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 control-label">Type Action </label>
                                    <div class="col-md-9">
                                        @Html.DropDownList("typeValue", ViewBag.ListType as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @id = "type", @name = "typeValue" })
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 control-label">Treshold </label>
                                    <div class="col-md-9">
                                        <input type="text" name="tresholdValue" id="treshold" class="form-control uniform" />
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 control-label">Operator </label>
                                    <div class="col-md-9">
                                        @Html.DropDownList("operatorValue", ViewBag.ListOperator as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @id = "operator", @name = "operatorValue" })
                                    </div>
                                </div>
                                <div class="form-actions">
                                    <button id="addButton" type="button" class="btn btn-primary pull-right">Add</button>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <table class="table table-striped grid-table">
                                    <thead>
                                        <tr>
                                            <th class="grid-header">Name</th>
                                            <th class="grid-header">Type</th>
                                            <th class="grid-header">Treshold</th>
                                            <th class="grid-header">Operator</th>
                                            <th class="grid-header"></th>
                                        </tr>
                                    </thead>
                                    <tbody id="tableActionList">
                                        @if (Model.ActionRules.Count() > 0 && Model.ActionRules != null)
                                        {
                                            for (int idx = 0; idx < Model.ActionRules.Count; idx++)
                                            {
                                                <tr>
                                                    @Html.TextBoxFor(x => x.ActionRules[idx].ID, new { @class = "required", type = "hidden" })
                                                    <td>
                                                        @Html.TextBoxFor(x => x.ActionRules[idx].ActionID, new { @class = "form-control required", type = "hidden" })
                                                        @Model.ActionRules[idx].ActionName
                                                    </td>
                                                    <td>
                                                        @Html.TextBoxFor(x => x.ActionRules[idx].Type, new { @class = "form-control required", type = "hidden" })
                                                        @Model.ActionRules[idx].Type
                                                    </td>
                                                    <td>
                                                        @Html.TextBoxFor(x => x.ActionRules[idx].Treshold, new { @class = "form-control required", type = "hidden" })
                                                        @Model.ActionRules[idx].Treshold
                                                    </td>
                                                    <td>
                                                        @Html.TextBoxFor(x => x.ActionRules[idx].Operator, new { @class = "form-control required", type = "hidden" })
                                                        @Model.ActionRules[idx].Operator
                                                    </td>
                                                    <td><input type="button" value="Delete Row" onclick="DeleteRow(this)" /></td>
                                                </tr>
                                            }
                                        }
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    <div class="form-actions">
                        <input type="submit" value="Submit" class="btn btn-primary pull-right">
                    </div>

                }
            </div>
        </div>
        <!-- /Validation Example 1 -->
    </div>
</div>
@section FooterScript{
    <script>
        function showThis(it) {
            str = $('#cekExpiredPerUser').prop("checked");
            if (str == false) {
                document.getElementById(it).style.display = "none";
            }
            else {
                document.getElementById(it).style.display = "block";
            }
        }

        str = $('#cekExpiredPerUser').prop("checked");
        if (str == false) {
            document.getElementById("formExpire").style.display = "none";
        }
        else {
            document.getElementById("formExpire").style.display = "block";
        }

        function showMe(it) {
            str = $('#cekAutomate').prop("checked");
            if (str == false) {
                document.getElementById(it).style.display = "none";
            }
            else {
                document.getElementById(it).style.display = "block";
            }
        }
        $(document).ready(function () {
            var initDualListBox = function () {
                if ($.configureBoxes) {
                    $.configureBoxes();
                }
            }
            str = $('#cekAutomate').prop("checked");
            if (str == false) {
                document.getElementById("formRole").style.display = "none";
            }
            else {
                document.getElementById("formRole").style.display = "block";
            }
            initDualListBox();
            $(".datepicker2").datepicker({
                defaultDate: +7,
                showOtherMonths: true,
                autoSize: true,
                appendText: '<span class="help-block">(dd/mm/yyyy)</span>',
                dateFormat: 'dd/mm/yy',
            });


            //===== Validation =====//
            //for default options, see assets/js/plugins.form-components.js (initValidation())

            $.extend($.validator.defaults, {
                invalidHandler: function (form, validator) {
                    var errors = validator.numberOfInvalids();
                    if (errors) {
                        var message = errors == 1
                            ? 'You missed 1 field. It has been highlighted.'
                            : 'You missed ' + errors + ' fields. They have been highlighted.';
                        noty({
                            text: message,
                            type: 'error',
                            timeout: 2000
                        });
                    }
                },
                errorPlacement: function (error, element) {
                    if (element.attr('type') === "file" && element.data('style') === "fileinput") {
                        error.appendTo(element.closest("div.fileinput-holder").parent('div'));
                    } else {
                        error.insertAfter(element)
                    }
                }
            });

            $("#formEditCampaign").validate();

            $('#nameAction').append($('#box2View').html());

            $('button#to1, button#to2, button#allto1, button#allto2').click(function () {
                $('select[name=CampaignActionList] option').prop('selected', true);
                $('select#nameAction').html($('select[name=CampaignActionList]').html());
            });
            $('select[name=CampaignActionList] option').prop('selected', true);

            $('#box1Filter, #box2Filter').keypress(function (event) {
                if (event.keyCode === 10 || event.keyCode === 13)
                    event.preventDefault();
            })
            $('button#addButton').click(function (event) {
                var name = $('#nameAction option:selected').text();
                var nameValue = $('#nameAction option:selected').val();
                var type = $('#type').val();
                var operator = $('#operator').val();
                var treshold = $('#treshold').val();
                //console.log(name);
                //"ActionRules[0].Type"
                var i = ($('tbody#tableActionList').find('tr').length - 1);
                $('#tableActionList').append('<tr><td><input type="hidden" name = "ActionRules[' + (i + 1) + '].ActionID" value="' + nameValue + '" />' + name + '</td><td><input type="hidden" name = "ActionRules[' + (i + 1) + '].Type" value="' + type + '" />' + type + '</td><td><input type="hidden" name = "ActionRules[' + (i + 1) + '].Treshold" value="' + treshold + '" />' + treshold + '</td><td><input type="hidden" name = "ActionRules[' + (i + 1) + '].Operator" value="' + operator + '" />' + operator + '</td><td><input type="button" value="Delete Row" onclick="DeleteRow(this)"/></td></tr>');
                event.preventDefault();
                //alert(name);
            })
        });
        function DeleteRow(r) {
            var i = r.parentNode.parentNode.rowIndex - 1;
            document.getElementById("tableActionList").deleteRow(i);
            $('tbody#tableActionList tr').each(function (idx, el) {
                $(el).find('input[name*=ActionRules]').each(function (idx2, el2) {
                    var currName = $(el2).attr('name');
                    var regex = /[0-9]+/ig;
                    $(el2).attr('name', currName.replace(regex, idx));
                })
            });
        }
    </script>
}